<template>
  <DeviceEditorPage
      :mode="DeviceEditorMode.EDIT_EXISTING"
      :cancel-button="CancelButton.BACK"
      :device="device"
      :online="device.online"
      :step="step"
      :error="error"
      :in-progress="inProgress"
      :remove-in-progress="removeInProgress"
      @input="onInput"
      @cancel="onCancel"
      @save="onSave"
      @done="onDone"
      @delete="onDelete"
  />
</template>

<script>
  import { createNamespacedHelpers } from 'vuex'

  import DeviceEditorPage from '@/pages/device-editor/component/DeviceEditorPage'
  import { CancelButton, DeviceEditorMode, DeviceEditorStep } from '@/pages/device-editor/component/consts'

  const { mapState } = createNamespacedHelpers('editDevice')

  export default {
    name: 'EditDevicePage',
    components: { DeviceEditorPage },
    data: () => ({
      step: DeviceEditorStep.EDIT_DEVICE,
      CancelButton: CancelButton,
      DeviceEditorMode: DeviceEditorMode
    }),
    computed: {
      ...mapState([ 'inProgress', 'removeInProgress', 'error', 'deviceStatus', 'device' ])
    },
    methods: {
      onInput() {
        if (this.error) {
          this.$store.commit('editDevice/resetError')
        }
      },
      onCancel() {
        this.onInput()
        if (this.error) {
          this.$store.commit('editDevice/resetError')
        }
        this.step = DeviceEditorStep.EDIT_DEVICE
      },
      onSave(device) {
        this.onInput()
        this.$store.dispatch('editDevice/loadStatus', {
          device: device,
          onSuccess: (() => {
            this.step = DeviceEditorStep.CHOOSE_NAME
          }).bind(this)
        })
      },
      onDone(deviceValue) {
        this.onInput()
        this.$store.dispatch('editDevice/updateDevice', {
          device: deviceValue,
          deviceId: this.device.deviceId,
          online: this.device.online,
          onSuccess: (() => {
            this.$router.push('chooseDevice')
          }).bind(this)
        })
      },
      onDelete() {
        this.onInput()
        this.$store.dispatch('editDevice/deleteDevice', {
          deviceId: this.device.deviceId,
          onSuccess: (() => {
            this.$router.push('chooseDevice')
          }).bind(this)
        })
      }
    }
  }
</script>